<?php
define("DIR_SMS", DIR_FS_CATALOG."zensms/");
define("AUTO_LOAD", DIR_FS_CATALOG."includes/auto_loaders/");
define("ADMIN_AUTO_LOAD", DIR_FS_ADMIN."includes/auto_loaders/");

class ot_zensms extends base 
{
    var $code;
    var $title;
    var $description;
    var $enabled;

    static public $lang_iso = array('aa' => 'Afar',  'ab' => 'Abkhaz',  'ae' => 'Avestan',  'af' => 'Afrikaans',  'ak' => 'Akan',  'am' => 'Amharic',  'an' => 'Aragonese',  'ar' => 'Arabic',  'as' => 'Assamese',  'av' => 'Avaric',  'ay' => 'Aymara',  'az' => 'Azerbaijani',  'ba' => 'Bashkir',  'be' => 'Belarusian',  'bg' => 'Bulgarian',  'bh' => 'Bihari',  'bi' => 'Bislama',  'bm' => 'Bambara',  'bn' => 'Bengali',  'bo' => 'Tibetan Standard, Tibetan, Central',  'br' => 'Breton',  'bs' => 'Bosnian',  'ca' => 'Catalan; Valencian',  'ce' => 'Chechen',  'ch' => 'Chamorro',  'co' => 'Corsican',  'cr' => 'Cree',  'cs' => 'Czech',  'cu' => 'Old Church Slavonic, Church Slavic, Church Slavonic, Old Bulgarian, Old Slavonic',  'cv' => 'Chuvash',  'cy' => 'Welsh',  'da' => 'Danish',  'de' => 'German',  'dv' => 'Divehi; Dhivehi; Maldivian;',  'dz' => 'Dzongkha',  'ee' => 'Ewe',  'el' => 'Greek, Modern',  'en' => 'English',  'eo' => 'Esperanto',  'es' => 'Spanish; Castilian',  'et' => 'Estonian',  'eu' => 'Basque',  'fa' => 'Persian',  'ff' => 'Fula; Fulah; Pulaar; Pular',  'fi' => 'Finnish',  'fj' => 'Fijian',  'fo' => 'Faroese',  'fr' => 'French',  'fy' => 'Western Frisian',  'ga' => 'Irish',  'gd' => 'Scottish Gaelic; Gaelic',  'gl' => 'Galician',  'gn' => 'GuaranÃ­',  'gu' => 'Gujarati',  'gv' => 'Manx',  'ha' => 'Hausa',  'he' => 'Hebrew (modern)',  'hi' => 'Hindi',  'ho' => 'Hiri Motu',  'hr' => 'Croatian',  'ht' => 'Haitian; Haitian Creole',  'hu' => 'Hungarian',  'hy' => 'Armenian',  'hz' => 'Herero',  'ia' => 'Interlingua',  'id' => 'Indonesian',  'ie' => 'Interlingue',  'ig' => 'Igbo',  'ii' => 'Nuosu',  'ik' => 'Inupiaq',  'io' => 'Ido',  'is' => 'Icelandic',  'it' => 'Italian',  'iu' => 'Inuktitut',  'ja' => 'Japanese (ja)',  'jv' => 'Javanese (jv)',  'ka' => 'Georgian',  'kg' => 'Kongo',  'ki' => 'Kikuyu, Gikuyu',  'kj' => 'Kwanyama, Kuanyama',  'kk' => 'Kazakh',  'kl' => 'Kalaallisut, Greenlandic',  'km' => 'Khmer',  'kn' => 'Kannada',  'ko' => 'Korean',  'kr' => 'Kanuri',  'ks' => 'Kashmiri',  'ku' => 'Kurdish',  'kv' => 'Komi',  'kw' => 'Cornish',  'ky' => 'Kirghiz, Kyrgyz',  'la' => 'Latin',  'lb' => 'Luxembourgish, Letzeburgesch',  'lg' => 'Luganda',  'li' => 'Limburgish, Limburgan, Limburger',  'ln' => 'Lingala',  'lo' => 'Lao',  'lt' => 'Lithuanian',  'lu' => 'Luba-Katanga',  'lv' => 'Latvian',  'mg' => 'Malagasy',  'mh' => 'Marshallese',  'mi' => 'Maori',  'mk' => 'Macedonian',  'ml' => 'Malayalam',  'mn' => 'Mongolian',  'mr' => 'Marathi (Mara?hi)',  'ms' => 'Malay',  'mt' => 'Maltese',  'my' => 'Burmese',  'na' => 'Nauru',  'nb' => 'Norwegian BokmÃ¥l',  'nd' => 'North Ndebele',  'ne' => 'Nepali',  'ng' => 'Ndonga',  'nl' => 'Dutch',  'nn' => 'Norwegian Nynorsk',  'no' => 'Norwegian',  'nr' => 'South Ndebele',  'nv' => 'Navajo, Navaho',  'ny' => 'Chichewa; Chewa; Nyanja',  'oc' => 'Occitan',  'oj' => 'Ojibwe, Ojibwa',  'om' => 'Oromo',  'or' => 'Oriya',  'os' => 'Ossetian, Ossetic',  'pa' => 'Panjabi, Punjabi',  'pi' => 'Pali',  'pl' => 'Polish',  'ps' => 'Pashto, Pushto',  'pt' => 'Portuguese',  'qu' => 'Quechua',  'rm' => 'Romansh',  'rn' => 'Kirundi',  'ro' => 'Romanian, Moldavian, Moldovan',  'ru' => 'Russian',  'rw' => 'Kinyarwanda',  'sa' => 'Sanskrit (Sa?sk?ta)',  'sc' => 'Sardinian',  'sd' => 'Sindhi',  'se' => 'Northern Sami',  'sg' => 'Sango',  'si' => 'Sinhala, Sinhalese',  'sk' => 'Slovak',  'sl' => 'Slovene',  'sm' => 'Samoan',  'sn' => 'Shona',  'so' => 'Somali',  'sq' => 'Albanian',  'sr' => 'Serbian',  'ss' => 'Swati',  'st' => 'Southern Sotho',  'su' => 'Sundanese',  'sv' => 'Swedish',  'sw' => 'Swahili',  'ta' => 'Tamil',  'te' => 'Telugu',  'tg' => 'Tajik',  'th' => 'Thai',  'ti' => 'Tigrinya',  'tk' => 'Turkmen',  'tl' => 'Tagalog',  'tn' => 'Tswana',  'to' => 'Tonga (Tonga Islands)',  'tr' => 'Turkish',  'ts' => 'Tsonga',  'tt' => 'Tatar',  'tw' => 'Twi',  'ty' => 'Tahitian',  'ug' => 'Uighur, Uyghur',  'uk' => 'Ukrainian',  'ur' => 'Urdu',  'uz' => 'Uzbek',  've' => 'Venda',  'vi' => 'Vietnamese',  'vo' => 'VolapÃ¼k',  'wa' => 'Walloon',  'wo' => 'Wolof',  'xh' => 'Xhosa',  'yi' => 'Yiddish',  'yo' => 'Yoruba',  'za' => 'Zhuang, Chuang',  'zh' => 'Chinese',  'zu' => 'Zulu',  );

    function ot_zensms() 
    {

      $this->code = 'ot_zensms';
      $this->codeVersion = ZENSMS_VERSION;

      $this->title = v_about_version_zen." ".number_format(ZENSMS_VERSION, 2);
      $this->enabled = ((MODULE_SMS_STATUS == 'True') ? true : false);
      $this->description = v_about_copyright;
    }

    function process() 
    {
        return false;
    }
    
    function selection() 
    {
        return false;
    }

    function keys() 
    {
      return array('MODULE_SMS_LANG', 'MODULE_SMS_TIMEZONE');
    }
    
    function check() 
    {
        global $db;
        if (!isset($this->_check)) 
        {
            $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SMS_STATUS'");
            $this->_check = !$check_query->EOF;
        }
        return $this->_check;
    }
    
    function uninstallFile($file)
    {
        if(file_exists(DIR_FS_ADMIN.$file))
        {
            unlink(DIR_FS_ADMIN.$file);
        }       
    }
    
    function installFile($file)
    {
        if(!file_exists(DIR_FS_ADMIN.$file) && file_exists(DIR_SMS."install/admin/".$file))
        {
            copy(DIR_SMS."install/admin/".$file, DIR_FS_ADMIN.$file);
        }
    }

    function install() 
    {
        global $db;

        $result = $db->Execute("SELECT * FROM ".DB_PREFIX."configuration where configuration_key='STORE_COUNTRY'");

        if (!$result->EOF){
            $country = $result->fields["configuration_value"];          

            $result = $db->Execute("SELECT * FROM ".DB_PREFIX."countries where countries_id = '".mysql_escape_string($country)."'");

            if (!$result->EOF)
            {
                $isoCode = $result->fields["countries_iso_code_2"];  
                
                $timezoneArray = DateTimeZone::listIdentifiers(4096, $isoCode);
                $timezone = $timezoneArray;

                if(empty($timezone))
                {
                    $timezone[]='Europe/Prague';
                }
            } 
            else 
            {
                $timezone[]='Europe/Prague';	
            }
        } 
        else 
        {
            $timezone[]='Europe/Prague';	
        }
        
        $configTimezone = "zen_cfg_select_drop_down(array(";
        
        foreach($timezone as $item)
        {
            $configTimezone .= "array('id'=>'".$item."', 'text'=>'".$item."'),";
        }
        $configTimezone = substr($configTimezone, 0, strlen($configTimezone)-1);
        $configTimezone .= "),";
        $configTimezone = mysql_escape_string($configTimezone);
        
        $d = dir(DIR_FS_CATALOG."zensms/lang/");
        $configList = "zen_cfg_select_drop_down(array(";
        
        while (false !== ($entry = $d->read())) 
        {
            if(is_dir(DIR_FS_CATALOG."zensms/lang/".$entry) && $entry != ".." && $entry != ".")
            {
                $configList .= "array('id'=>'".$entry."', 'text'=>'".self::$lang_iso[$entry]."'),";
            }
        }
        $configList = substr($configList, 0, strlen($configList)-1);
        $configList .= "),";
        $configList = mysql_escape_string($configList);
        $d->close();
        
        $db->Execute("REPLACE INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('This module is installed', 'MODULE_SMS_STATUS', 'True', '', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
        $db->Execute("REPLACE INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Module language', 'MODULE_SMS_LANG', 'en', '', '6', '0', '".$configList."', now())");
        $db->Execute("REPLACE INTO " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Module timezone', 'MODULE_SMS_TIMEZONE', 'Europe/Prague', '', '6', '0', '".$configTimezone."', now())");
       
        $db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_settings (
                                `ID` int(5) NOT NULL AUTO_INCREMENT,
                                `name` varchar(100) CHARACTER SET utf8 NOT NULL,
                                 `value` text NOT NULL,
                                PRIMARY KEY (`ID`)
                                ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;");
         
        $db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_optout_prices (
                                `ID` int(7) NOT NULL AUTO_INCREMENT,
                                `shop_id` int(5) NOT NULL,
                                `price` double(10,4) NOT NULL,
                                `currency` varchar(20) NOT NULL,
                                `active` tinyint(3) NOT NULL,
                                PRIMARY KEY (`ID`)
                              ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;");

        $db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_optout_texts (
                                `ID` int(7) NOT NULL AUTO_INCREMENT,
                                `shop_id` int(5) NOT NULL,
                                `text` text NOT NULL,
                                `lang` varchar(20) NOT NULL,
                                PRIMARY KEY (`ID`)
                              ) ENGINE=MyISAM  DEFAULT CHARSET=utf8;");
         
        $db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_optout_deleted (
                                `ID` int(10) NOT NULL AUTO_INCREMENT,
                                `order_id` int(10) NOT NULL,
                                PRIMARY KEY (`ID`)
                              ) ENGINE=MyISAM DEFAULT CHARSET=utf8;");
         
        $result = $db->Execute("SELECT count(*) as count FROM ".DB_PREFIX."sp_settings where name like 'AppID'");

        if (!$result->EOF)
        {
            $row = $result->fields;
            $counter = $row["count"]; 
        }
        
        if (!$counter>0)
        {
               $db->Execute("INSERT INTO ".DB_PREFIX."sp_settings values (NULL , 'AppID', '".rand(1000000,90000000)."' )");
        }     
        unset($counter);
        
        $db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_smsuser (
                            `ID` tinyint(1) NOT NULL AUTO_INCREMENT,
                            `user` varchar(55) CHARACTER SET utf8 NOT NULL,
                            `passwd` varchar(55) CHARACTER SET utf8 NOT NULL,
                            `email` varchar(100) CHARACTER SET utf8 NOT NULL,
                            `companyname` varchar(100) CHARACTER SET utf8 NOT NULL,
                            `addressstreet` varchar(100) CHARACTER SET utf8 NOT NULL,
                            `addresscity` varchar(100) CHARACTER SET utf8 NOT NULL,
                            `addresszip` varchar(100) CHARACTER SET utf8 NOT NULL,
                            `country0` varchar(100) CHARACTER SET utf8 NOT NULL,
                            `companyid` varchar(100) CHARACTER SET utf8 NOT NULL,
                            `companyvat` varchar(100) CHARACTER SET utf8 NOT NULL,
                            `simulatesms` tinyint(3) NOT NULL,
                            `deletedb` tinyint(3) NOT NULL,
                            `pocetkredit` int(6) NOT NULL,
                            `deliveryemail` varchar(100) NOT NULL,
                            `URLreports` tinyint(3) NOT NULL,
                            `kosoba` varchar(100) CHARACTER SET utf8 NOT NULL,
                            `kprijmeni` varchar(100) CHARACTER SET utf8 NOT NULL,
                            PRIMARY KEY (`ID`)
                            ) ENGINE=MyISAM  DEFAULT CHARSET=utf8  ;");

        $db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_admins (
					`ID` int(5) NOT NULL AUTO_INCREMENT,
					`name` varchar(100) CHARACTER SET utf8 NOT NULL,
					`number` varchar(20) CHARACTER SET utf8 NOT NULL,
					PRIMARY KEY (`ID`)
					) ENGINE=MyISAM  DEFAULT CHARSET=utf8;");

	$db->Execute("CREATE TABLE IF NOT EXISTS `".DB_PREFIX."sp_hooks_admins_multi` (
                                        `name` varchar(100) NOT NULL,
                                        `status` bigint(25) NOT NULL,
                                        `smstext` text NOT NULL,
                                        `adminIDs` varchar(250) NOT NULL,
                                        `storeID` int(5) NOT NULL
                                      ) ENGINE=MyISAM DEFAULT CHARSET=utf8;");

	$db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_hooks_customers (
					`name` varchar(100) CHARACTER SET utf8 NOT NULL,
					`status` bigint(25) NOT NULL,
					`smstext` text CHARACTER SET utf8 NOT NULL,
					`active` tinyint(3) NOT NULL,
  					`mutation` varchar(100) NOT NULL
					) ENGINE=MyISAM DEFAULT CHARSET=utf8;");

	$db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_hooks_templates (
					`area` varchar(10) CHARACTER SET utf8 NOT NULL,
					`area_text` varchar(50) CHARACTER SET utf8 NOT NULL,
					UNIQUE KEY `area` (`area`)
					) ENGINE=MyISAM DEFAULT CHARSET=utf8;");

	$db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_hooks_unicode (
					`area` varchar(10) NOT NULL,
					`unicode` tinyint(3) NOT NULL,
					`type` varchar(10) NOT NULL
					) ENGINE=MyISAM DEFAULT CHARSET=utf8;");

	$db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_ownnumbersenderIDs (
					`ownnumbersenderID` varchar(30) CHARACTER SET utf8 NOT NULL,
					UNIQUE KEY `textsenderID` (`ownnumbersenderID`)
					) ENGINE=MyISAM DEFAULT CHARSET=utf8;");

	$db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_routes (
					`area` int(5) NOT NULL,
					`type` varchar(20) CHARACTER SET utf8 NOT NULL,
					`isms` int(5) NOT NULL,
					`sendertype` tinyint(3) NOT NULL,
					`senderID` varchar(30) CHARACTER SET utf8 NOT NULL,
					`info` text CHARACTER SET utf8 NOT NULL,
					`area_text` varchar(50) CHARACTER SET utf8 NOT NULL
					) ENGINE=MyISAM DEFAULT CHARSET=utf8;");

	$db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_sms_history (
					`ID` int(8) NOT NULL AUTO_INCREMENT,
					`number` varchar(30) NOT NULL,
					`date` datetime NOT NULL,
					`text` text NOT NULL,
					`status` tinyint(3) NOT NULL,
					`price` double(5,3) NOT NULL,
					`credit` double(15,3) NOT NULL,
					`sender` varchar(30) NOT NULL,
					`unicode` tinyint(3) NOT NULL,
					`type` tinyint(3) NOT NULL,
					`smsID` varchar(220) NOT NULL,
					`note` varchar(100) NOT NULL,
					`total` tinyint(3) NOT NULL,
					`admin_ID` int(8) NOT NULL,
					`customer_ID` int(8) NOT NULL,
					`recipient` varchar(100) NOT NULL,
					`subject` varchar(100) NOT NULL,
                                        `change` tinyint(1) NOT NULL DEFAULT '1',
                                        `campaign` int(11) DEFAULT NULL,
					PRIMARY KEY (`ID`),
					KEY `vyber1` (`date`),
					KEY `vyber2` (`date`,`type`),
					KEY `vyber3` (`date`,`type`,`status`)
					) ENGINE=MyISAM  DEFAULT CHARSET=utf8;");

	$db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_textsenderIDs (
					`textsenderID` varchar(11) CHARACTER SET utf8 NOT NULL,
					UNIQUE KEY `textsenderID` (`textsenderID`)
					) ENGINE=MyISAM DEFAULT CHARSET=utf8;");

	$db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_answers (
					`ID` int(5) NOT NULL AUTO_INCREMENT,
					`text` text NOT NULL,
					`from` varchar(50) NOT NULL DEFAULT '',
					`prohlednuto` tinyint(3) NOT NULL DEFAULT '0',
					`smsc` varchar(100) NOT NULL DEFAULT '',
					`cas` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
					PRIMARY KEY (`ID`)
					) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;");

	$db->Execute("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."sp_outofstock (
					`ID` int(8) NOT NULL AUTO_INCREMENT,
					`datum` date NOT NULL,
					`product_ID` int(8) NOT NULL,
					PRIMARY KEY (`ID`)
					) ENGINE=MyISAM DEFAULT CHARSET=utf8 ;");
        
        $result = $db->Execute("DESCRIBE " . DB_PREFIX . "sp_sms_history");

        if (!$result->EOF) 
        {
            while(!$result->EOF)
            {
                $historyTable[] = $result->fields["Field"];
                $result->MoveNext();
            }
            if (count($historyTable) && !in_array("change", $historyTable))
            {
                $db->Execute("ALTER TABLE `" . DB_PREFIX . "sp_sms_history` ADD COLUMN `change` tinyint(1) NOT NULL DEFAULT 1;");
            }

            if (count($historyTable) && !in_array("campaign", $historyTable))
            {
                $db->Execute("ALTER TABLE `" . DB_PREFIX . "sp_sms_history` ADD COLUMN `campaign` int(11) DEFAULT NULL;");
            }
        }

        $db->Execute("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "sp_marketing_filter` (
                                        `id` int(11) NOT NULL AUTO_INCREMENT,
                                        `name` varchar(200) NOT NULL,
                                        `filter` text,
                                        `disabled` text,
                                        `disabled_counter` int(11) NOT NULL DEFAULT '0',
                                        `date` datetime NOT NULL,
                                        PRIMARY KEY (`id`)
                                      ) ENGINE=InnoDB AUTO_INCREMENT=32 DEFAULT CHARSET=utf8;");

        $db->Execute("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "sp_template` (
                                        `id` int(11) NOT NULL AUTO_INCREMENT,
                                        `name` varchar(200) NOT NULL,
                                        `template` text,
                                        `unicode` tinyint(1) NOT NULL DEFAULT '0',
                                        `unique` tinyint(1) NOT NULL DEFAULT '0',
                                        `date` datetime NOT NULL,
                                        `type` int(11) NOT NULL,
                                        PRIMARY KEY (`id`)
                                      ) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;");

        $db->Execute("CREATE TABLE IF NOT EXISTS `" . DB_PREFIX . "sp_exceptions` (
                                    `id` int(11) NOT NULL AUTO_INCREMENT,
                                    `prefix` int(11) NOT NULL,
                                    `firstPrefix` int(11) NOT NULL,
                                    `length` int(11) NOT NULL,
                                    `trim` int(11) NOT NULL,
                                    PRIMARY KEY (`id`)
                                  ) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8;");
        
        $db->Execute("CREATE TABLE IF NOT EXISTS `" .DB_PREFIX. "sp_config` (
                                    `shop_id` int(11) NOT NULL,
                                    `config_name` varchar(200) NOT NULL,
                                    `config_value` text NOT NULL,
                                    PRIMARY KEY (`shop_id`,`config_name`)
                                  ) ENGINE=InnoDB DEFAULT CHARSET=utf8;");

        
        if(intval(substr(PROJECT_VERSION_MINOR, 0,1)) >= 5){
            
            $db->Execute("INSERT INTO `".DB_PREFIX."admin_menus` (`menu_key`, `language_key`, `sort_order`) VALUES ('sms', 'BOX_HEADING_SMS', '999')");
        
            zen_register_admin_page('smsUser', 'BOX_SMSUSER', 'FILENAME_SMSUSER','' , 'sms', 'Y', 900);
            zen_register_admin_page('smsSend', 'BOX_SMSSEND', 'FILENAME_SMSSEND','' , 'sms', 'Y', 901);
            zen_register_admin_page('smsMarketing', 'BOX_SMSMARKETING', 'FILENAME_SMSMARKETING','' , 'sms', 'Y', 902);
            zen_register_admin_page('smsHistory', 'BOX_SMSHISTORY', 'FILENAME_SMSHISTORY','' , 'sms', 'Y', 903);
            zen_register_admin_page('smsStatistics', 'BOX_SMSSTATISTICS', 'FILENAME_SMSSTATISTICS','' , 'sms', 'Y', 904);
            zen_register_admin_page('smsReply', 'BOX_SMSREPLY', 'FILENAME_SMSREPLY','' , 'sms', 'Y', 905);
            zen_register_admin_page('smsAdmin', 'BOX_SMSADMIN', 'FILENAME_SMSADMIN','' , 'sms', 'Y', 906);
            zen_register_admin_page('smsCustomer', 'BOX_SMSCUSTOMER', 'FILENAME_SMSCUSTOMER','' , 'sms', 'Y', 907);
            zen_register_admin_page('smsOptOut', 'BOX_SMSOPTOUT', 'FILENAME_SMSOPTOUT','' , 'sms', 'Y', 908);
            zen_register_admin_page('smsSetings', 'BOX_SMSSETINGS', 'FILENAME_SMSSETINGS','' , 'sms', 'Y', 909);
            zen_register_admin_page('smsBuyCredit', 'BOX_SMSBUYCREDIT', 'FILENAME_SMSBUYCREDIT','' , 'sms', 'Y', 910);
            zen_register_admin_page('smsAbout', 'BOX_SMSABOUT', 'FILENAME_SMSABOUT','' , 'sms', 'Y', 911);
        }
    }
  
    function remove() 
    {
        global $db;
        
        $configures = $this->keys();
        $configures[] = "MODULE_SMS_STATUS";
             
        $result = $db->Execute("SELECT deletedb FROM ".DB_PREFIX."sp_smsuser WHERE ID=1");
        $db->Execute("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key IN ('" . implode("', '", $configures) . "')");

        if(!$result->EOF && $result->fields["deletedb"] == 1)
        {
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_settings"); 
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_smsuser");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_admins");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_hooks_admins_multi");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_hooks_customers");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_hooks_templates");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_hooks_unicode");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_ownnumbersenderIDs");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_routes");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_sms_history");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_textsenderIDs");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_answers");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_outofstock");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_optout_deleted");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_optout_prices");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_optout_texts");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_marketing_filter");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_template");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_exceptions");
            $db->Execute("DROP TABLE IF EXISTS ".DB_PREFIX."sp_config");
        }

        if(intval(substr(PROJECT_VERSION_MINOR, 0,1)) >= 5)
        {
            $db->Execute("DELETE FROM `".DB_PREFIX."admin_menus` WHERE (`menu_key`='sms');");
            zen_deregister_admin_pages("smsUser");
            zen_deregister_admin_pages('smsSend');
            zen_deregister_admin_pages('smsMarketing');
            zen_deregister_admin_pages('smsHistory');
            zen_deregister_admin_pages('smsStatistics');
            zen_deregister_admin_pages('smsReply');
            zen_deregister_admin_pages('smsAdmin');
            zen_deregister_admin_pages('smsCustomer');
            zen_deregister_admin_pages('smsOptOut');
            zen_deregister_admin_pages('smsSetings');
            zen_deregister_admin_pages('smsBuyCredit');
            zen_deregister_admin_pages('smsAbout');
        }
        else
        {
            unset($_SESSION["sms_status"]);
        }       
    }
}

?>
